/* Performance timer class for Linux
** copyleft (C) Shawn Kirst (skirst@fuse.net) 2000
**
** you may email me for all questions and comments about this code.
*/

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __TIMER_H
#define __TIMER_H

typedef long long qword;

extern __inline__ qword cputicks(void) {
	__asm__("rdtsc");
}

struct timer_t {

   timer_t() { counter=cputicks(); total=interval=0; }

   int init(void);
   inline double passed(void) {
      return((double)((cputicks()-counter)*freq)/1000000);
   }
   void update(void);

   double total;
   double interval;

protected:

   double freq;
   qword counter;

};

#endif //ifndef __TIMER_H
